#include <bits/stdc++.h>
using namespace std;
#define int long long
const int MAXN = 2e5+5;
const int inf = (1ll<<31)-1;


int n;
int a[MAXN], b[MAXN];

void solve(){
	cin >> n;
	for(int i = 0; i < n; ++i){
		cin >> a[i];
	}
	for(int i = 0; i < n; ++i){
		cin >> b[i];
	}
	if(n <= 2005){
		int r = 0;
		for(int i = 0; i < n; ++i){
			int x = 0, y = inf;
			for(int j = i; j < n; ++j){
				x ^= a[j];
				y &= b[j];
				r = max(r, x*y);
			}
		}
		cout << r << '\n';
		return;
	}
	bool da = 1;
	for(int i = 0; i < n; ++i){
		if(a[i]!=1){
			da = 0;
			break;
		}
	}
	if(da){
		int r = 0;
		for(int i = 0; i < n; ++i){
			r = max(r, b[i]);
		}
		return;
	}
	cout << 5;
}

int32_t main(){
	ios_base::sync_with_stdio(0); cin.tie(0);
	int qqq=1;
	//cin>>qqq;
	while(qqq--)solve();
	return 0;
}